'******************************************************************
'Benutzereinstellungen:
'******************************************************************
SQLServer=  "Server\SQLEXPRESS"
SQLUser=    "Web"
SQLPW=      "web"
DWH=        "MpTvDbRC2"
Zeitdiff =  3
'******************************************************************




'SystemSettings
Set WshShell = Wscript.CreateObject("WScript.Shell")
Set FSO = CreateObject("Scripting.FileSystemObject")
Scriptpfad= replace(wscript.ScriptFullName,wscript.Scriptname,"")
Scriptstart=now()

'Datenbank ffnen
Set DB1 = CreateObject("ADODB.Connection")
Set DB2 = CreateObject("ADODB.Connection")
db1.Open("Driver={SQL Server};SERVER="&SQLServer&";Database="&DWH&";User ID="&SQLUser&";Password="&SQLPW)
db2.Open("Driver={SQL Server};SERVER="&SQLServer&";Database="&DWH&";User ID="&SQLUser&";Password="&SQLPW)

'Prfen ob eigene Tabelle schon besteht, ggf anlegen
set rs1=db1.execute("select count(*) as Anzahl from INFORMATION_SCHEMA.TABLES where TABLE_NAME='LightsOut'")
if rs1("Anzahl")=0 then
db1.execute("create table dbo.LightsOut (id_Schedule int, Datum varchar(30))")
end if

'Prfen ob neue Eintrge vorhanden sind:
set rs1=db1.execute("SELECT Schedule.id_Schedule, Schedule.programName, dateadd(minute,(preRecordInterval*-1)-"&Zeitdiff&",startTime) as start, dateadd(minute,postRecordInterval+"&Zeitdiff&",endTime) as Ende " & _
                    "FROM Schedule LEFT JOIN LightsOut ON Schedule.id_Schedule = LightsOut.id_Schedule " & _
                    "where LightsOut.id_Schedule is null and Schedule.endTime>current_timestamp")
if not rs1.bof then

   'XML einlesen und als XML2 speichern.
   set FileIn=fso.opentextfile("C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.xml")
   set Fileout=fso.createtextfile("C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.xml2",1)

   'gelesene XML schreiben bis '</List>' gefunden wird
   strline=FileIn.readline
     Do while instr(strline,"</List>")=0
     fileout.writeline strline
     strline=FileIn.readline
     loop

   do while not rs1.eof
   'Original Zeitangaben ermitteln
   sO=rs1("start")
   eO=rs1("Ende")

   'Zeitangaben umwandeln ins LightsOut-Format
   Start=year(sO)&"-"&right("00"&month(sO),2)&"-"&right("00"&day(sO),2)&"T"&right("00"&hour(sO),2)&":"&right("00"&minute(sO),2)&":00"
   Ende=year(eO)&"-"&right("00"&month(eO),2)&"-"&right("00"&day(eO),2)&"T"&right("00"&hour(eO),2)&":"&right("00"&minute(eO),2)&":00"

   'XML Zeile bilden. Name des Eintrags besteht aus Titel / Startzeit / Zeitpunkt Erstellung
   XML=replace("    <LoTask Days='None' EndDate='"&Ende&"' Force='false' Mode='TimeSpan' Name='MP"&replace(rs1("id_Schedule"),chr(34),"")&"' OnEnd='DoNothing' OnStart='WakeUp' StartDate='"&Start&"' />","'",chr(34))
   fileout.writeline XML
   db2.execute ("insert into lightsout values (0"&rs1("id_Schedule")&",'"&Scriptstart&"')")



   rs1.movenext
   loop

   fileout.writeline strline

   Do While FileIn.AtEndOfStream = False
   fileout.writeline FileIn.readline

   loop

   'Dateien schlieen
   fileIn.close
   fileout.close

   'Backup von Original anlegen fals noch keins besteht
   if not fso.fileexists("C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.bak") then
   fso.copyfile "C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.xml","C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.bak"
   end if

   'Orginal-XML berschreiben
   on error resume next
   fso.copyfile "C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.xml2","C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\LightsOut\TaskList.xml",1

   'Wenn Fehler aufgetreten ist, Kennzeichen fr bertragen lschen
   if Err.Number<>0 then
   db2.execute("delete from lightsout where Datum='"&Scriptstart&"'")
   end if

end if